﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stormtrooper
{
    internal class StormtrooperCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xStorm = x as DrawningObjectStorm;
            var yStorm = y as DrawningObjectStorm;
            if (xStorm == null && yStorm == null)
            {
                return 0;
            }
            if (xStorm == null && yStorm != null)
            {
                return 1;
            }
            if (xStorm != null && yStorm == null)
            {
                return -1;
            }

            var baseColorCompare = xStorm.GetStormtrooper.Storm.BodyColor.ToString().CompareTo(yStorm.GetStormtrooper.Storm.BodyColor.ToString());
            if (baseColorCompare != 0)
            {
                return baseColorCompare;
            }

            if (xStorm.GetStormtrooper.Storm is EntityMilitaryStormtrooper xDDB && yStorm.GetStormtrooper.Storm is EntityMilitaryStormtrooper yDDB)
            {
                var extraColorCompare = xDDB.BodyColor.ToString().CompareTo(yDDB.BodyColor.ToString());
                if (extraColorCompare != 0)
                {
                    return extraColorCompare;
                }
            }

            return 0;
        }
    }
}
