﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stormtrooper
{
    internal class StormtrooperCompareByType : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xStorm = x as DrawningObjectStorm;
            var yStorm = y as DrawningObjectStorm;
            if (xStorm == null && yStorm == null)
            {
                return 0;
            }
            if (xStorm == null && yStorm != null)
            {
                return 1;
            }
            if (xStorm != null && yStorm == null)
            {
                return -1;
            }
            if (xStorm.GetStormtrooper.GetType().Name != yStorm.GetStormtrooper.GetType().Name)
            {
                if (xStorm.GetStormtrooper.GetType().Name == "Drawning")
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xStorm.GetStormtrooper.Storm.Speed.CompareTo(yStorm.GetStormtrooper.Storm.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xStorm.GetStormtrooper.Storm.Weight.CompareTo(yStorm.GetStormtrooper.Storm.Weight);
        }
    }
}
